src/config/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static

from students.views import index

urlpatterns = [
    path("__debug__/", include("debug_toolbar.urls")),
    path("", index, name="index"),
    path("admin/", admin.site.urls),
    path("students/", include("students.urls")),
    path("teachers/", include("teachers.urls")),
    path("groups/", include("groups.urls")),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

src/groups/urls.py
from django.urls import path
from groups.views import get_groups, create_group, update_group, delete_group, group_detail


app_name = "groups"

urlpatterns = [
    path("", get_groups, name="all_groups"),
    path("create/", create_group, name="create_group"),
    path("update/<int:pk>/", update_group, name="update_group"),
    path("delete/<int:pk>/", delete_group, name="delete_group"),
    path("group/<int:pk>/", group_detail, name="group_detail"),
]

src/teachers/urls.py
from django.urls import path
from teachers.views import get_teachers, create_teacher, update_teacher, delete_teacher


app_name = "teachers"

urlpatterns = [
    path("", get_teachers, name="all_teachers"),
    path("create/", create_teacher, name="create_teacher"),
    path("update/<int:pk>/", update_teacher, name="update_teacher"),
    path("delete/<int:pk>/", delete_teacher, name="delete_teacher"),
]

src/teachers/models.py
import random
from django.db import models
from faker import Faker

from groups.models import Group
from main.models import Person, avatar_upload_path

random = random.Random()


class Teacher(Person):
    international_certificates = models.BooleanField(default=False, null=True, blank=True)
    previous_work_place = models.CharField(max_length=120, null=True, blank=True)
    experience = models.BooleanField(default=False, null=True, blank=True)
    availability_per_week = models.PositiveSmallIntegerField(null=True, blank=True)
    groups = models.ManyToManyField(Group, related_name="teachers")
    avatar = models.ImageField(upload_to=avatar_upload_path, null=True, blank=True)

    @classmethod
    def generate_instances(cls, count):
        fake = Faker()
        for _ in range(count):
            teacher = cls.objects.create(
                first_name=fake.first_name(),
                last_name=fake.last_name(),
                email=fake.email(),
                birth_date=fake.date_of_birth(minimum_age=18, maximum_age=60),
                international_certificates=random.choice([True, False]),
                previous_work_place=fake.company(),
                experience=random.choice([True, False]),
                availability_per_week=random.randint(10, 40),
            )
            groups = Group.objects.filter(id__in=random.sample(range(1, 41), random.randint(1, 5)))
            teacher.groups.set(groups)

    def __str__(self):
        return f"{self.first_name} {self.last_name} {self.email} ({self.pk})"

src/teachers/forms.py
from django.core.exceptions import ValidationError
from django.forms import ModelForm

from teachers.models import Teacher


class TeacherForm(ModelForm):
    class Meta:
        model = Teacher
        fields = [
            "first_name",
            "last_name",
            "email",
            "availability_per_week",
            "experience",
            "international_certificates",
            "groups",
            "avatar",
        ]

    @staticmethod
    def normalize_text(text: str) -> str:
        return text.strip().capitalize()

    def clean_email(self):
        email = self.cleaned_data["email"]

        if "@yandex" in email.lower():
            raise ValidationError("Yandex is not a valid email address!!!")
        return email

    def clean_last_name(self):
        return self.normalize_text(self.cleaned_data["last_name"])

    def clean_first_name(self):
        return self.normalize_text(self.cleaned_data["first_name"])

    def clean(self):
        cleaned_data = super().clean()

        first_name = cleaned_data["first_name"]
        last_name = cleaned_data["last_name"]

        if first_name == last_name:
            raise ValidationError("First name and last name cannot be equal!")

        return cleaned_data

src/teachers/views.py
from django.db.models import Q
from django.http import HttpResponseRedirect
from django.shortcuts import get_object_or_404, render
from django.urls import reverse
from webargs import fields
from webargs.djangoparser import use_args

from teachers.forms import TeacherForm
from teachers.models import Teacher


@use_args(
    {
        "first_name": fields.Str(
            required=False,
        ),
        "last_name": fields.Str(
            required=False,
        ),
        "search": fields.Str(
            required=False,
        ),
    },
    location="query",
)
def get_teachers(request, params):
    teachers = Teacher.objects.all()

    search_fields = ["first_name", "last_name", "email"]

    for param_name, param_value in params.items():
        if param_name == "search":
            or_filter = Q()
            for field in search_fields:
                or_filter |= Q(**{f"{field}__icontains": param_value})
            teachers = teachers.filter(or_filter)
        else:
            teachers = teachers.filter(**{param_name: param_value})

    return render(request, template_name="teachers/teacher_list.html", context={"teachers": teachers})


def create_teacher(request):
    if request.method == "POST":
        form = TeacherForm(request.POST, request.FILES)
        if form.is_valid():
            form.save()
            return HttpResponseRedirect(reverse("teachers:all_teachers"))
    elif request.method == "GET":
        form = TeacherForm()
    return render(request, template_name="teachers/teacher_create.html", context={"form": form})


def update_teacher(request, pk):
    teacher = get_object_or_404(Teacher.objects.all(), pk=pk)
    if request.method == "POST":
        form = TeacherForm(request.POST, request.FILES, instance=teacher)
        if form.is_valid():
            form.save()
            return HttpResponseRedirect(reverse("teachers:all_teachers"))
    elif request.method == "GET":
        form = TeacherForm(instance=teacher)
    return render(request, template_name="teachers/teacher_update.html", context={"form": form})


def delete_teacher(request, pk):
    teacher = get_object_or_404(Teacher.objects.all(), pk=pk)
    if request.method == "POST":
        teacher.delete()
        return HttpResponseRedirect(reverse("teachers:all_teachers"))
    elif request.method == "GET":
        pass
    return render(request, template_name="teachers/teacher_delete.html", context={"teacher": teacher})

src/templates/teachers/teacher_create.html
{% extends "index.html" %}
{% load crispy_forms_filters %}

{% block content %}
    <div>
        <form method="post" enctype="multipart/form-data" style="width: 25em; margin: auto">
            {% csrf_token %}
            {{ form|crispy }}
            <br>
            <button type="submit" class="btn btn-primary" value="Submit">Submit</button>
        </form>
    </div>
{% endblock content %}

src/templates/teachers/teacher_delete.html
{% extends "index.html" %}
{% load crispy_forms_filters %}

{% block content %}
    <div>
        <form method="post" style="width: 25em; margin: auto">
            {% csrf_token %}
            <p> Teacher {{ teacher.first_name }} {{ teacher.last_name }} will be deleted.</p>
            <br>
            <button type="submit" class="btn btn-danger" value="Delete">Delete</button>
        </form>
    </div>
{% endblock content %}

src/templates/teachers/teacher_list.html
{% extends "index.html" %}
{% load crispy_forms_filters %}
{% load static %}

{% block content %}
    <div>
        <table class="table table-dark table-striped">
            <thead>
            <tr>
                <th scope="col">Avatar</th>
                <th scope="col">First name</th>
                <th scope="col">Last name</th>
                <th scope="col">Email</th>
                <th scope="col">Birth date</th>
                <th scope="col">Experience</th>
                <th scope="col">International certificates</th>
                <th scope="col">Availability per week</th>
                <th scope="col">Groups</th>
            </tr>
            </thead>
            <tbody>
            {% for teacher in teachers %}
                <tr>
                    <td>
                        {% if teacher.avatar %}
                            <img src="{{ teacher.avatar.url }}" alt="Avatar" width="30" height="30">
                        {% else %}
                            <img alt="Default avatar" src="{% static "img/default_avatar.png" %}" width="30" height="30">
                        {% endif %}
                    </td>
                    <td>{{ teacher.first_name }}</td>
                    <td>{{ teacher.last_name }}</td>
                    <td>{{ teacher.email }}</td>
                    {% if teacher.birth_date %}
                        <td>{{ teacher.birth_date }}</td>
                    {% else %}
                        <td>Invalid birth date</td>
                    {% endif %}
                    <td>{{ teacher.experience }}</td>
                    <td>{{ teacher.international_certificates }}</td>
                    <td>{{ teacher.availability_per_week }}</td>
                    <td>
                        <ul>
                            {% for group in teacher.groups.all %}
                                <li><a href="{% url 'groups:group_detail' group.pk %}">{{ group.group_name }}</a></li>
                            {% empty %}
                                <li>No groups found</li>
                            {% endfor %}
                        </ul>
                    </td>
                    <th>
                        <a type="button" class="btn btn-warning" href="{% url "teachers:update_teacher" teacher.pk %}">Edit</a>
                    </th>
                    <th>
                        <a type="button" class="btn btn-danger" href="{% url "teachers:delete_teacher" teacher.pk %}">Delete</a>
                    </th>
                </tr>
            {% endfor %}
            </tbody>
        </table>
    </div>
{% endblock content %}


{% block header %}
<a class="nav-link" href="{% url 'teachers:create_teacher' %}">Add new teacher</a>
{% endblock header %}

src/templates/teachers/teacher_update.html
{% extends "index.html" %}
{% load crispy_forms_filters %}

{% block content %}
    <div>
        <form method="post" enctype="multipart/form-data" style="width: 25em; margin: auto">
            {% csrf_token %}
            {{ form|crispy }}
            <br>
            <button type="submit" class="btn btn-primary" value="Update">Update</button>
        </form>
    </div>
{% endblock content %}